# frozen_string_literal: true

require 'landline'
require 'landline/extensions/websocket'

class Test < Landline::App
  websocket "/test", version: 7 do |socket|
    socket.on :message do |msg|
      puts "Client wrote: #{msg}"
    end
    socket.on :error do |err|
      puts "Error occured: #{err.inspect}"
      puts err.backtrace
    end
    socket.on :close do
      puts "Client closed read connection"
    end
    socket.ready
    socket.write("Hi!")
    response = socket.read
    socket.write("You said: #{response}")
    socket.write("Goodbye!")
    socket.close
  rescue Exception => e
    puts e.inspect
    puts e.backtrace
  end
end

run Test.new
